/**
  * 	This program reads words from the pipe
  *	Sorts the words and writes the sorted words into a pipe  
  */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define MSGSIZ 6
#define PIPE_LENGTH 3
#define FIFO_NAME "PIPE1_2"

char 	a[10000][20];

void swap(int i, int j)
{
	int 	k;
	char 	temp;

  for(k=0;k<20;k++)
  {
    temp = a[i][k];
    a[i][k] = a[j][k];
    a[j][k] = temp;
  }

}

void Sort(int C)
{
int 	i,j;

  for (i=0;i<C;i++)

    for(j=i+1;j<C;j++)

      if (strcmp(a[i],a[j]) > 0) swap(i,j);

}



void printout(int C)

{

	int 	count,i,fd;
	char 	msgbuf[MSGSIZ+1];

	    	mknod("PIPE2_3", S_IFIFO | 0666, 0);
    		printf("waiting for reader...\n");
    		fd = open("PIPE2_3", O_WRONLY);
    		printf("got a reader\n");

	for(i=0;i<C;i++)
	{

		if((count=write(fd,a[i],strlen(a[i])+1))==-1)

		perror("Writing to pipe");

		else

		printf("Program 2: wrote %d %s\n",count,a[i]);

	}

if(count=write(fd,"*******************************",32)){}

}



int main()

{

	int var=0,num;

	int i=0,pipe_count=0,current=0;

	int fd,k=0,count;
	char ch,msgbuf[1000],s[1000];


	   mknod(FIFO_NAME, S_IFIFO | 0666, 0);
	   printf("waiting for writers...\n");
	   fd = open(FIFO_NAME, O_RDONLY);
	   printf("got a writer\n");

while(ch!='*')
{



if((count=read(fd,msgbuf,MSGSIZ))==-1)
	perror("read");
else

{

	printf("Program 2: Message received %d : %s\n",count,msgbuf);

	var=0;


	while(var<MSGSIZ)

	{

		while (msgbuf[var]!=' ' && var < MSGSIZ)

			a[current][i++]=msgbuf[var++];

		if(msgbuf[var]==' ')
		{
			a[current][i]='\0';
			i=0;
			current++;
			var++;
		}
	}	


}

ch=msgbuf[0];

}

Sort(current);
printout(current);
}





