/**
  *	This programs reads words from the pipe
  *	Calculates the frequency for each word
  *  	Displays the frequency
  */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define FIFO_NAME "PIPE2_3"

#define MSGSIZ 6

int  PIPE_LENGTH=2;

int main()
{

int 	fd,i=0,fl=0,nb=0,k=0,j=0;
char	msgbuf[MSGSIZ+1],ch=' ';
char 	words[10000][100];
char 	present[100];
int 	Freq[10000],mask=0;

	   //Making a nemed pipe(FIFO) for reading sorted words
	    mknod(FIFO_NAME, S_IFIFO | 0666, 0);
	    printf("waiting for a writer...\n");
	    fd = open(FIFO_NAME, O_RDONLY);
	    printf("got a writer........\n");

	
	//Now read data from file letter by letter and form words

	while(ch!='*')
	{
		k=0;

		if((nb=read(fd,msgbuf,MSGSIZ))==-1)
			perror("Read operation failed from pipe");

		while (k<MSGSIZ)
		{
			present[i++]=msgbuf[k];
			if(msgbuf[k]=='\0' || msgbuf[k]==' ')
			{
				mask=0;
				if(i==1)
				{
					i=0;
					break;
				}
				present[i]='\0';


			printf("Program 3: Read ---%s\n",present);

				for(j=0;j<fl;j++)
				{

					if(strcmp(present,words[j])==0)
					{
						Freq[j]+=1;
						i=0;
						mask=1;
						break;
					}
				}

				if(mask==0)
				{
					strcpy(words[fl],present);
					Freq[fl]=1;
					fl++;
					i=0;
				}
			}
			k++;
	
		}
		ch=msgbuf[0]; //cheking for end of sorted words
		
	}

	//Printing word frequency
	for(i=0;i<fl;i++)
		printf("\nFreq of %-20s  :  %d", words[i], Freq[i]);

		printf("\nEnd of Program 3\n");

}

